MethodUtils (Apache Commons Lang 3.17.0 API)
Description: declaration: package: org.apache.commons.lang3.reflect, class: MethodUtils

Package org.apache.commons.lang3.reflect

# Class MethodUtils

java.lang.Object
org.apache.commons.lang3.reflect.MethodUtils

public class MethodUtils extends Object
Utility reflection methods focused on `Method`s, originally from Commons BeanUtils. Differences from the BeanUtils version may be noted, especially where similar functionality already existed within Lang.

## Known Limitations

### Accessing Public Methods In A Default Access Superclass

There is an issue when invoking `public` methods contained in a default access superclass on JREs prior to 1.4. Reflection locates these methods fine and correctly assigns them as `public`. However, an `IllegalAccessException` is thrown if the method is invoked.

`MethodUtils` contains a workaround for this situation. It will attempt to call `AccessibleObject.setAccessible(boolean)` on this method. If this call succeeds, then the method can be invoked as normal. This call will only succeed when the application has sufficient security privileges. If this call fails then the method may fail.

Since:
  2.5

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `MethodUtils()`
  Deprecated.
  TODO Make private in 4.0.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static Method`
  `getAccessibleMethod(Class<?> cls, String methodName, Class<?>... parameterTypes)`
  Gets an accessible method (that is, one that can be invoked via reflection) with given name and parameters.
  `static Method`
  `getAccessibleMethod(Method method)`
  Gets an accessible method (that is, one that can be invoked via reflection) that implements the specified Method.
  `static <A extends Annotation>
  A`
  `getAnnotation(Method method, Class<A> annotationCls, boolean searchSupers, boolean ignoreAccess)`
  Gets the annotation object with the given annotation type that is present on the given method or optionally on any equivalent method in super classes and interfaces.
  `static Method`
  `getMatchingAccessibleMethod(Class<?> cls, String methodName, Class<?>... parameterTypes)`
  Gets an accessible method that matches the given name and has compatible parameters.
  `static Method`
  `getMatchingMethod(Class<?> cls, String methodName, Class<?>... parameterTypes)`
  Gets a method whether or not it's accessible.
  `static Method`
  `getMethodObject(Class<?> cls, String name, Class<?>... parameterTypes)`
  Gets a Method or null if a `documented` exception is thrown.
  `static List<Method>`
  `getMethodsListWithAnnotation(Class<?> cls, Class<? extends Annotation> annotationCls)`
  Gets all class level public methods of the given class that are annotated with the given annotation.
  `static List<Method>`
  `getMethodsListWithAnnotation(Class<?> cls, Class<? extends Annotation> annotationCls, boolean searchSupers, boolean ignoreAccess)`
  Gets all methods of the given class that are annotated with the given annotation.
  `static Method[]`
  `getMethodsWithAnnotation(Class<?> cls, Class<? extends Annotation> annotationCls)`
  Gets all class level public methods of the given class that are annotated with the given annotation.
  `static Method[]`
  `getMethodsWithAnnotation(Class<?> cls, Class<? extends Annotation> annotationCls, boolean searchSupers, boolean ignoreAccess)`
  Gets all methods of the given class that are annotated with the given annotation.
  `static Set<Method>`
  `getOverrideHierarchy(Method method, ClassUtils.Interfaces interfacesBehavior)`
  Gets the hierarchy of overridden methods down to `result` respecting generics.
  `static Object`
  `invokeExactMethod(Object object, String methodName)`
  Invokes a method whose parameter types match exactly the object types.
  `static Object`
  `invokeExactMethod(Object object, String methodName, Object... args)`
  Invokes a method with no parameters.
  `static Object`
  `invokeExactMethod(Object object, String methodName, Object[] args, Class<?>[] parameterTypes)`
  Invokes a method whose parameter types match exactly the parameter types given.
  `static Object`
  `invokeExactStaticMethod(Class<?> cls, String methodName, Object... args)`
  Invokes a `static` method whose parameter types match exactly the object types.
  `static Object`
  `invokeExactStaticMethod(Class<?> cls, String methodName, Object[] args, Class<?>[] parameterTypes)`
  Invokes a `static` method whose parameter types match exactly the parameter types given.
  `static Object`
  `invokeMethod(Object object, boolean forceAccess, String methodName)`
  Invokes a named method without parameters.
  `static Object`
  `invokeMethod(Object object, boolean forceAccess, String methodName, Object... args)`
  Invokes a named method whose parameter type matches the object type.
  `static Object`
  `invokeMethod(Object object, boolean forceAccess, String methodName, Object[] args, Class<?>[] parameterTypes)`
  Invokes a named method whose parameter type matches the object type.
  `static Object`
  `invokeMethod(Object object, String methodName)`
  Invokes a named method without parameters.
  `static Object`
  `invokeMethod(Object object, String methodName, Object... args)`
  Invokes a named method whose parameter type matches the object type.
  `static Object`
  `invokeMethod(Object object, String methodName, Object[] args, Class<?>[] parameterTypes)`
  Invokes a named method whose parameter type matches the object type.
  `static Object`
  `invokeStaticMethod(Class<?> cls, String methodName, Object... args)`
  Invokes a named `static` method whose parameter type matches the object type.
  `static Object`
  `invokeStaticMethod(Class<?> cls, String methodName, Object[] args, Class<?>[] parameterTypes)`
  Invokes a named `static` method whose parameter type matches the object type.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### MethodUtils

    @Deprecated public MethodUtils()
    Deprecated.
    TODO Make private in 4.0.
    `MethodUtils` instances should NOT be constructed in standard programming. Instead, the class should be used as `MethodUtils.getAccessibleMethod(method)`.

    This constructor is `public` to permit tools that require a JavaBean instance to operate.

- ## Method Details

  - ### getAccessibleMethod

    public static Method getAccessibleMethod(Class<?> cls, String methodName, Class<?>... parameterTypes)
    Gets an accessible method (that is, one that can be invoked via reflection) with given name and parameters. If no such method can be found, return `null`. This is just a convenience wrapper for `getAccessibleMethod(Method)`.
    Parameters:
      `cls` - get method from this class
      `methodName` - get method with this name
      `parameterTypes` - with these parameters types
    Returns:
      The accessible method

  - ### getAccessibleMethod

    public static Method getAccessibleMethod(Method method)
    Gets an accessible method (that is, one that can be invoked via reflection) that implements the specified Method. If no such method can be found, return `null`.
    Parameters:
      `method` - The method that we wish to call, may be null.
    Returns:
      The accessible method

  - ### getAnnotation

    public static <A extends Annotation> A getAnnotation(Method method, Class<A> annotationCls, boolean searchSupers, boolean ignoreAccess)
    Gets the annotation object with the given annotation type that is present on the given method or optionally on any equivalent method in super classes and interfaces. Returns null if the annotation type was not present.

    Stops searching for an annotation once the first annotation of the specified type has been found. Additional annotations of the specified type will be silently ignored.

    Type Parameters:
      `A` - the annotation type
    Parameters:
      `method` - the `Method` to query, may be null.
      `annotationCls` - the `Annotation` to check if is present on the method
      `searchSupers` - determines if a lookup in the entire inheritance hierarchy of the given class is performed if the annotation was not directly present
      `ignoreAccess` - determines if underlying method has to be accessible
    Returns:
      the first matching annotation, or `null` if not found
    Throws:
      `NullPointerException` - if either the method or annotation class is `null`
    Since:
      3.6

  - ### getMatchingAccessibleMethod

    public static Method getMatchingAccessibleMethod(Class<?> cls, String methodName, Class<?>... parameterTypes)
    Gets an accessible method that matches the given name and has compatible parameters. Compatible parameters mean that every method parameter is assignable from the given parameters. In other words, it finds a method with the given name that will take the parameters given.

    This method is used by `invokeMethod(Object object, String methodName, Object[] args, Class[] parameterTypes)`.

    This method can match primitive parameter by passing in wrapper classes. For example, a `Boolean` will match a primitive `boolean` parameter.

    Parameters:
      `cls` - find method in this class
      `methodName` - find method with this name
      `parameterTypes` - find method with most compatible parameters
    Returns:
      The accessible method

  - ### getMatchingMethod

    public static Method getMatchingMethod(Class<?> cls, String methodName, Class<?>... parameterTypes)
    Gets a method whether or not it's accessible. If no such method can be found, return `null`.
    Parameters:
      `cls` - The class that will be subjected to the method search
      `methodName` - The method that we wish to call
      `parameterTypes` - Argument class types
    Returns:
      The method
    Throws:
      `IllegalStateException` - if there is no unique result
      `NullPointerException` - if the class is `null`
    Since:
      3.5

  - ### getMethodObject

    public static Method getMethodObject(Class<?> cls, String name, Class<?>... parameterTypes)
    Gets a Method or null if a `documented` exception is thrown.
    Parameters:
      `cls` - Receiver for `Class.getMethod(String, Class...)`.
      `name` - the name of the method
      `parameterTypes` - the list of parameters
    Returns:
      a Method or null.
    Since:
      3.15.0
    See Also:
      - `Class.getMethod(String, Class...)`

  - ### getMethodsListWithAnnotation

    public static List<Method> getMethodsListWithAnnotation(Class<?> cls, Class<? extends Annotation> annotationCls)
    Gets all class level public methods of the given class that are annotated with the given annotation.
    Parameters:
      `cls` - the `Class` to query
      `annotationCls` - the `Annotation` that must be present on a method to be matched
    Returns:
      a list of Methods (possibly empty).
    Throws:
      `NullPointerException` - if the class or annotation are `null`
    Since:
      3.4

  - ### getMethodsListWithAnnotation

    public static List<Method> getMethodsListWithAnnotation(Class<?> cls, Class<? extends Annotation> annotationCls, boolean searchSupers, boolean ignoreAccess)
    Gets all methods of the given class that are annotated with the given annotation.
    Parameters:
      `cls` - the `Class` to query
      `annotationCls` - the `Annotation` that must be present on a method to be matched
      `searchSupers` - determines if a lookup in the entire inheritance hierarchy of the given class should be performed
      `ignoreAccess` - determines if non-public methods should be considered
    Returns:
      a list of Methods (possibly empty).
    Throws:
      `NullPointerException` - if either the class or annotation class is `null`
    Since:
      3.6

  - ### getMethodsWithAnnotation

    public static Method[] getMethodsWithAnnotation(Class<?> cls, Class<? extends Annotation> annotationCls)
    Gets all class level public methods of the given class that are annotated with the given annotation.
    Parameters:
      `cls` - the `Class` to query
      `annotationCls` - the `Annotation` that must be present on a method to be matched
    Returns:
      an array of Methods (possibly empty).
    Throws:
      `NullPointerException` - if the class or annotation are `null`
    Since:
      3.4

  - ### getMethodsWithAnnotation

    public static Method[] getMethodsWithAnnotation(Class<?> cls, Class<? extends Annotation> annotationCls, boolean searchSupers, boolean ignoreAccess)
    Gets all methods of the given class that are annotated with the given annotation.
    Parameters:
      `cls` - the `Class` to query
      `annotationCls` - the `Annotation` that must be present on a method to be matched
      `searchSupers` - determines if a lookup in the entire inheritance hierarchy of the given class should be performed
      `ignoreAccess` - determines if non-public methods should be considered
    Returns:
      an array of Methods (possibly empty).
    Throws:
      `NullPointerException` - if the class or annotation are `null`
    Since:
      3.6

  - ### getOverrideHierarchy

    public static Set<Method> getOverrideHierarchy(Method method, ClassUtils.Interfaces interfacesBehavior)
    Gets the hierarchy of overridden methods down to `result` respecting generics.
    Parameters:
      `method` - lowest to consider
      `interfacesBehavior` - whether to search interfaces, `null` `implies` false
    Returns:
      a `Set<Method>` in ascending order from sub- to superclass
    Throws:
      `NullPointerException` - if the specified method is `null`
    Since:
      3.2

  - ### invokeExactMethod

    public static Object invokeExactMethod(Object object, String methodName) throws NoSuchMethodException, IllegalAccessException, InvocationTargetException
    Invokes a method whose parameter types match exactly the object types.

    This uses reflection to invoke the method obtained from a call to `getAccessibleMethod(java.lang.Class<?>, java.lang.String, java.lang.Class<?>...)`(Class, String, Class[])}.

    Parameters:
      `object` - invoke method on this object
      `methodName` - get method with this name
    Returns:
      The value returned by the invoked method
    Throws:
      `NoSuchMethodException` - if there is no such accessible method
      `InvocationTargetException` - wraps an exception thrown by the method invoked
      `IllegalAccessException` - if the requested method is not accessible via reflection
    Since:
      3.4

  - ### invokeExactMethod

    public static Object invokeExactMethod(Object object, String methodName, Object... args) throws NoSuchMethodException, IllegalAccessException, InvocationTargetException
    Invokes a method with no parameters.

    This uses reflection to invoke the method obtained from a call to `getAccessibleMethod(java.lang.Class<?>, java.lang.String, java.lang.Class<?>...)`(Class, String, Class[])}.

    Parameters:
      `object` - invoke method on this object
      `methodName` - get method with this name
      `args` - use these arguments - treat null as empty array
    Returns:
      The value returned by the invoked method
    Throws:
      `NoSuchMethodException` - if there is no such accessible method
      `InvocationTargetException` - wraps an exception thrown by the method invoked
      `IllegalAccessException` - if the requested method is not accessible via reflection
      `NullPointerException` - if the object or method name are `null`

  - ### invokeExactMethod

    public static Object invokeExactMethod(Object object, String methodName, Object[] args, Class<?>[] parameterTypes) throws NoSuchMethodException, IllegalAccessException, InvocationTargetException
    Invokes a method whose parameter types match exactly the parameter types given.

    This uses reflection to invoke the method obtained from a call to `getAccessibleMethod(Class, String, Class[])`.

    Parameters:
      `object` - invoke method on this object
      `methodName` - get method with this name
      `args` - use these arguments - treat null as empty array
      `parameterTypes` - match these parameters - treat `null` as empty array
    Returns:
      The value returned by the invoked method
    Throws:
      `NoSuchMethodException` - if there is no such accessible method
      `InvocationTargetException` - wraps an exception thrown by the method invoked
      `IllegalAccessException` - if the requested method is not accessible via reflection
      `NullPointerException` - if the object or method name are `null`

  - ### invokeExactStaticMethod

    public static Object invokeExactStaticMethod(Class<?> cls, String methodName, Object... args) throws NoSuchMethodException, IllegalAccessException, InvocationTargetException
    Invokes a `static` method whose parameter types match exactly the object types.

    This uses reflection to invoke the method obtained from a call to `getAccessibleMethod(Class, String, Class[])`.

    Parameters:
      `cls` - invoke static method on this class
      `methodName` - get method with this name
      `args` - use these arguments - treat `null` as empty array
    Returns:
      The value returned by the invoked method
    Throws:
      `NoSuchMethodException` - if there is no such accessible method
      `InvocationTargetException` - wraps an exception thrown by the method invoked
      `IllegalAccessException` - if the requested method is not accessible via reflection

  - ### invokeExactStaticMethod

    public static Object invokeExactStaticMethod(Class<?> cls, String methodName, Object[] args, Class<?>[] parameterTypes) throws NoSuchMethodException, IllegalAccessException, InvocationTargetException
    Invokes a `static` method whose parameter types match exactly the parameter types given.

    This uses reflection to invoke the method obtained from a call to `getAccessibleMethod(Class, String, Class[])`.

    Parameters:
      `cls` - invoke static method on this class
      `methodName` - get method with this name
      `args` - use these arguments - treat `null` as empty array
      `parameterTypes` - match these parameters - treat `null` as empty array
    Returns:
      The value returned by the invoked method
    Throws:
      `NoSuchMethodException` - if there is no such accessible method
      `InvocationTargetException` - wraps an exception thrown by the method invoked
      `IllegalAccessException` - if the requested method is not accessible via reflection

  - ### invokeMethod

    public static Object invokeMethod(Object object, boolean forceAccess, String methodName) throws NoSuchMethodException, IllegalAccessException, InvocationTargetException
    Invokes a named method without parameters.

    This is a convenient wrapper for `invokeMethod(Object object, boolean forceAccess, String methodName, Object[] args, Class[] parameterTypes)`.

    Parameters:
      `object` - invoke method on this object
      `forceAccess` - force access to invoke method even if it's not accessible
      `methodName` - get method with this name
    Returns:
      The value returned by the invoked method
    Throws:
      `NoSuchMethodException` - if there is no such accessible method
      `InvocationTargetException` - wraps an exception thrown by the method invoked
      `IllegalAccessException` - if the requested method is not accessible via reflection
    Since:
      3.5

  - ### invokeMethod

    public static Object invokeMethod(Object object, boolean forceAccess, String methodName, Object... args) throws NoSuchMethodException, IllegalAccessException, InvocationTargetException
    Invokes a named method whose parameter type matches the object type.

    This method supports calls to methods taking primitive parameters via passing in wrapping classes. So, for example, a `Boolean` object would match a `boolean` primitive.

    This is a convenient wrapper for `invokeMethod(Object object, boolean forceAccess, String methodName, Object[] args, Class[] parameterTypes)`.

    Parameters:
      `object` - invoke method on this object
      `forceAccess` - force access to invoke method even if it's not accessible
      `methodName` - get method with this name
      `args` - use these arguments - treat null as empty array
    Returns:
      The value returned by the invoked method
    Throws:
      `NoSuchMethodException` - if there is no such accessible method
      `InvocationTargetException` - wraps an exception thrown by the method invoked
      `IllegalAccessException` - if the requested method is not accessible via reflection
      `NullPointerException` - if the object or method name are `null`
    Since:
      3.5

  - ### invokeMethod

    public static Object invokeMethod(Object object, boolean forceAccess, String methodName, Object[] args, Class<?>[] parameterTypes) throws NoSuchMethodException, IllegalAccessException, InvocationTargetException
    Invokes a named method whose parameter type matches the object type.

    This method supports calls to methods taking primitive parameters via passing in wrapping classes. So, for example, a `Boolean` object would match a `boolean` primitive.

    Parameters:
      `object` - invoke method on this object
      `forceAccess` - force access to invoke method even if it's not accessible
      `methodName` - get method with this name
      `args` - use these arguments - treat null as empty array
      `parameterTypes` - match these parameters - treat null as empty array
    Returns:
      The value returned by the invoked method
    Throws:
      `NoSuchMethodException` - if there is no such accessible method
      `InvocationTargetException` - wraps an exception thrown by the method invoked
      `IllegalAccessException` - if the requested method is not accessible via reflection
      `NullPointerException` - if the object or method name are `null`
    Since:
      3.5

  - ### invokeMethod

    public static Object invokeMethod(Object object, String methodName) throws NoSuchMethodException, IllegalAccessException, InvocationTargetException
    Invokes a named method without parameters.

    This method delegates the method search to `getMatchingAccessibleMethod(Class, String, Class[])`.

    This is a convenient wrapper for `invokeMethod(Object object, String methodName, Object[] args, Class[] parameterTypes)`.

    Parameters:
      `object` - invoke method on this object
      `methodName` - get method with this name
    Returns:
      The value returned by the invoked method
    Throws:
      `NoSuchMethodException` - if there is no such accessible method
      `InvocationTargetException` - wraps an exception thrown by the method invoked
      `IllegalAccessException` - if the requested method is not accessible via reflection
    Since:
      3.4

  - ### invokeMethod

    public static Object invokeMethod(Object object, String methodName, Object... args) throws NoSuchMethodException, IllegalAccessException, InvocationTargetException
    Invokes a named method whose parameter type matches the object type.

    This method delegates the method search to `getMatchingAccessibleMethod(Class, String, Class[])`.

    This method supports calls to methods taking primitive parameters via passing in wrapping classes. So, for example, a `Boolean` object would match a `boolean` primitive.

    This is a convenient wrapper for `invokeMethod(Object object, String methodName, Object[] args, Class[] parameterTypes)`.

    Parameters:
      `object` - invoke method on this object
      `methodName` - get method with this name
      `args` - use these arguments - treat null as empty array
    Returns:
      The value returned by the invoked method
    Throws:
      `NoSuchMethodException` - if there is no such accessible method
      `InvocationTargetException` - wraps an exception thrown by the method invoked
      `IllegalAccessException` - if the requested method is not accessible via reflection
      `NullPointerException` - if the object or method name are `null`

  - ### invokeMethod

    public static Object invokeMethod(Object object, String methodName, Object[] args, Class<?>[] parameterTypes) throws NoSuchMethodException, IllegalAccessException, InvocationTargetException
    Invokes a named method whose parameter type matches the object type.

    This method delegates the method search to `getMatchingAccessibleMethod(Class, String, Class[])`.

    This method supports calls to methods taking primitive parameters via passing in wrapping classes. So, for example, a `Boolean` object would match a `boolean` primitive.

    Parameters:
      `object` - invoke method on this object
      `methodName` - get method with this name
      `args` - use these arguments - treat null as empty array
      `parameterTypes` - match these parameters - treat null as empty array
    Returns:
      The value returned by the invoked method
    Throws:
      `NoSuchMethodException` - if there is no such accessible method
      `InvocationTargetException` - wraps an exception thrown by the method invoked
      `IllegalAccessException` - if the requested method is not accessible via reflection

  - ### invokeStaticMethod

    public static Object invokeStaticMethod(Class<?> cls, String methodName, Object... args) throws NoSuchMethodException, IllegalAccessException, InvocationTargetException
    Invokes a named `static` method whose parameter type matches the object type.

    This method delegates the method search to `getMatchingAccessibleMethod(Class, String, Class[])`.

    This method supports calls to methods taking primitive parameters via passing in wrapping classes. So, for example, a `Boolean` class would match a `boolean` primitive.

    This is a convenient wrapper for `invokeStaticMethod(Class, String, Object[], Class[])`.

    Parameters:
      `cls` - invoke static method on this class
      `methodName` - get method with this name
      `args` - use these arguments - treat `null` as empty array
    Returns:
      The value returned by the invoked method
    Throws:
      `NoSuchMethodException` - if there is no such accessible method
      `InvocationTargetException` - wraps an exception thrown by the method invoked
      `IllegalAccessException` - if the requested method is not accessible via reflection

  - ### invokeStaticMethod

    public static Object invokeStaticMethod(Class<?> cls, String methodName, Object[] args, Class<?>[] parameterTypes) throws NoSuchMethodException, IllegalAccessException, InvocationTargetException
    Invokes a named `static` method whose parameter type matches the object type.

    This method delegates the method search to `getMatchingAccessibleMethod(Class, String, Class[])`.

    This method supports calls to methods taking primitive parameters via passing in wrapping classes. So, for example, a `Boolean` class would match a `boolean` primitive.

    Parameters:
      `cls` - invoke static method on this class
      `methodName` - get method with this name
      `args` - use these arguments - treat `null` as empty array
      `parameterTypes` - match these parameters - treat `null` as empty array
    Returns:
      The value returned by the invoked method
    Throws:
      `NoSuchMethodException` - if there is no such accessible method
      `InvocationTargetException` - wraps an exception thrown by the method invoked
      `IllegalAccessException` - if the requested method is not accessible via reflection